<!DOCTYPE html>
<html lang="en">

<head>
   <meta charset="UTF-8">
   <meta name="viewport" content="width=device-width, initial-scale=1.0">
   <meta http-equiv="X-UA-Compatible" content="ie=edge">
   <title>Document</title>
   <style>
      @charset "uft-8";

      mi-mensaje {
         display: block;
         padding: 10px;
         border: 5px solid black;
         margin-bottom: 10px;
      }

      mi-mensaje [casi-visible] {
         border: none;
      }
   </style>
</head>

<body>

   <mi-mensaje msj="Hola, soy un mensaje">Aquí</mi-mensaje>
   <mi-mensaje casi-visible msj="Hola, soy un mensaje casi-visible">Aquí x2</mi-mensaje>

   <script>

      class MiMensaje extends HTMLElement {
         constructor() {
            super();
            this.addEventListener('click', function (e) {
               alert('Click en mensaje');
            });
            console.log('constructor: Cuando el elemento es creado');
         }

         static get observedAttributes() {
            return ['msj', 'casi-visible'];
            // return ['msj'];
         }

         connectedCallback() {
            console.log('connectedCallback: Cuando el elemento es insertado en el documento');
         }

         disconnectedCallback() {
            alert('disconnected: Cuando el elemento es eliminado del documento');
         }

         adoptedCallback() {
            alert('adoptedCallback: Cuando el elemento es adoptado por otro documento');
         }

         attributeChangedCallback(attrName, oldVal, newVal) {
            console.log('attributeChangedCallback: Cuando cambia el atributo');
            if (attrName === 'msj') {
               this.pintarMensaje(newVal);
            }
            if (attrName === 'casi-visible') {
               this.setCasiVisible();
            }
         }

         pintarMensaje(msj) {
            this.innerHTML = msj;
         }

         get msj() {
            return this.getAttribute('msj');
         }

         set msj(val) {
            this.setAttribute('msj', val);
         }

         get casiVisible() {
            return this.hasAttribute('casi-visible');
         }

         set casiVisible(value) {
            if (value) {
               this.setAttribute('casi-visible', '');
            } else {
               this.removeAttribute('casi-visible')
            }
         }

         setCasiVisible() {
            if (this.casiVisible) {
               this.style.opacity = 0.1;
            } else {
               this.style.opacity = 1;
            }
         }

      }
      customElements.define('mi-mensaje', MiMensaje);

      let miMensaje = document.createElement('mi-mensaje')
      miMensaje.msj = 'Otro mensaje';
      document.body.appendChild(miMensaje);

      let tercerMensaje = new MiMensaje();
      tercerMensaje.msj = 'Tercer mensaje';

      document.body.appendChild(tercerMensaje);
   </script>
</body>

</html>